[题]P1150 Peter 的烟 #数学推导

题目

P1150 Peter 的烟

题解

为什么要记录这个入门题呢

因为一个题解:博客跳转

我自己做的是模拟整个吸烟然后烟蒂换烟的过程,很笨。

这个数学推导真的震撼我

最后一个式子就搞定:n+(n-1)/(k-1)

基于该题解的我的分析过程:

n个烟蒂可以换一根烟,这根烟吸完可以获得一个烟蒂

那么在烟蒂足够的情况下,每n-1个烟蒂就是一根烟

数学式表示为:n烟蒂 = 1烟 + 1烟蒂 => n-1烟蒂 = 1烟

但是这个代换有一个前提:你必须在一开始就有n个烟蒂

所以,重申一遍:烟蒂满足n个的情况下,每n-1个烟蒂就是一根烟

比如我每6个烟蒂才能换一根烟时,按照上面的推导我可以5个烟蒂换一根烟

但是我最后剩下的5个烟蒂还能这样换吗?显然不能。

所以我们一开始就将烟蒂总数减去1,使得最后的n-1个烟蒂变为n-2个

这个操作对前面的烟蒂是不会有影响的,前面的烟蒂会正常地被换掉

这样最后要是剩下n-1个烟蒂就不会进行交换

代码

我按照模拟吸烟的思路写的,能过。

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;
int main(){
	int n, k, sum;
	cin >> n >> k;
	sum = n;//原有的肯定会吸完 
	while(n >= k){//n此时代表的是烟蒂的数量
		int y = n / k;//换来y根烟 
		n %= k;//还剩下n个烟蒂 
		sum += y;
		n += y;//y根烟吸完后又来y个烟蒂 
	}
	cout << sum;
	return 0; 
}
相关推荐
hetao173383743 分钟前
2026-10-03~04 hetao1733837 的刷题记录
c++·算法
longlongzihan2 小时前
从LeetCode 70. 爬楼梯看动态规划:如何精准推导状态转移方程?
c++·算法·leetcode·动态规划
潼心1412o4 小时前
C++初阶(长期更新)第6讲:类和对象(下)
开发语言·c++·算法
-森屿安年-5 小时前
按身高排序
c++·算法
(Charon)6 小时前
【C++面试】vector底层原理:扩容、拷贝移动与迭代器失效
c++·面试
朔北之忘 Clancy6 小时前
青少年软编等考七级题解目录
开发语言·c++·青少年编程·gesp·csp·信奥赛·noi
汉克老师6 小时前
GESP2026年9月认证C++七级( 第一部分选择题(8~15题)精讲
c++·gesp·小学生·学c++编程
Mr_Macallon6 小时前
C++回顾(基础)(01)
c语言·开发语言·c++·学习
如意猴7 小时前
【C++】007 C/C++ 内存管理机制、malloc与new的区别及模板初阶
java·c++·算法
朝朝辞暮i7 小时前
C++ 第 32 课:main()、rclcpp::init()、spin()、shutdown()
开发语言·c++·算法